# Copyright (C) 2004 Philippe Normand <phil@respyre.org>
#
# This file is part of XMLObject (http://xmlobject.base-art.net)
#
# Under PSF License (see COPYING)

from types import UnicodeType
import classregistry

def lowWord(word):
    " FoObar -> foObar "
    return word[0].lower() + word[1:]

def titleWord(word):
    " foObar -> FoObar "
    return word[0].upper() + word[1:]

def encode(v,enc = "iso-8859-1"):
    if isinstance(v, UnicodeType):
        v = v.encode(enc)
    return v

def replaceAll(initialString, translationHash):
    """ for each (toReplace, replacement) in `translationHash`
        applying the query-replace operation to `initialString`
    """
    if type(initialString) != type(''):
        return initialString
    if initialString is None:
        result = ''
    else:
        result = initialString
    for key, value in translationHash:
        result = result.replace(key, value)
    return result

def contains(list1, list2):
    """ Check if some elements of list1 appear in list2

        Return the intersection of the two lists
    """
    result = []
    for it1 in list1:
        if it1 in list2:
            result.append(it1)
    return result

import xml.dom.minidom
def getDirectChildrenWithName(parent, name):
    rc = []
    for node in parent.childNodes:
	if node.nodeType == xml.dom.minidom.Node.ELEMENT_NODE:
	    if node.localName == name:
		rc.append(node)
    return rc
